VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Midinote sample by Matt Hart - vbhelp@matthart.com"
   ClientHeight    =   870
   ClientLeft      =   1635
   ClientTop       =   1545
   ClientWidth     =   5775
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   870
   ScaleWidth      =   5775
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   3780
      TabIndex        =   1
      Text            =   "96"
      Top             =   360
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Play it again, Sam."
      Default         =   -1  'True
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   300
      Width           =   1695
   End
   Begin VB.Label Label1 
      Caption         =   "Tempo:"
      Height          =   255
      Left            =   3000
      TabIndex        =   2
      Top             =   420
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Midinote sample by Matt Hart - vbhelp@matthart.com
' http://matthart.com
'
' This one plays a few MIDI notes to the default MIDI
' device, showing you the basics of streaming MIDI output.
'
' It is a translation of a C program sent to me by
' Pier Calderan in the ' form of a question ...
' "How do I get this to work in VB?".

Private Type midiHdr
    lpData As Long      ' As String
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    lpNext As Long
    Reserved As Long
    dwOffset As Long
    dwReserved(0 To 3) As Long
End Type
Private Type MIDIPROPTIMEDIV
    cbStruct As Long
    dwTimeDiv As Long
End Type

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function midiOutPrepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As Any, ByVal uSize As Long) As Long
Private Declare Function midiOutUnprepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As Any, ByVal uSize As Long) As Long
Private Declare Function midiStreamClose Lib "winmm.dll" (ByVal hms As Long) As Long
Private Declare Function midiStreamOpen Lib "winmm.dll" (phms As Long, puDeviceID As Long, ByVal cMidi As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal fdwOpen As Long) As Long
Private Declare Function midiStreamOut Lib "winmm.dll" (ByVal hms As Long, pmh As Any, ByVal cbmh As Long) As Long
Private Declare Function midiStreamProperty Lib "winmm.dll" (ByVal hms As Long, lppropdata As Any, ByVal dwProperty As Long) As Long
Private Declare Function midiStreamRestart Lib "winmm.dll" (ByVal hms As Long) As Long

Private Const GMEM_FIXED = &H0
Private Const GMEM_ZEROINIT = &H40
Private Const GPTR = (GMEM_FIXED Or GMEM_ZEROINIT)
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

Private Const MIDIMAPPER = (-1)
Private Const MMSYSERR_NOERROR = 0
Private Const MIDIERR_BASE = 64
Private Const MIDIERR_STILLPLAYING = (MIDIERR_BASE + 1)   '  still something playing
Private Const CALLBACK_NULL = &H0
Private Const MEVT_F_SHORT = &H0&
Private Const MIDIPROP_SET = &H80000000
Private Const MIDIPROP_TIMEDIV = &H1&

Private Sub Command1_Click()
    Dim Phrase(0 To 18) As Long
    
    Phrase(2) = &H7F3C90
    Phrase(3) = 32
    Phrase(5) = &H7F3E90
    Phrase(8) = &H7F4090
    Phrase(9) = 48
    Phrase(11) = &H3C90
    Phrase(12) = 48
    Phrase(14) = &H3E90
    Phrase(15) = 48
    Phrase(17) = &H4090
    
    Dim lSize As Long, uDevice As Long
    lSize = (UBound(Phrase) - LBound(Phrase) + 1) * Len(Phrase(0))
    uDevice = MIDIMAPPER
    
    Dim Handle As Long, mHdr As midiHdr, hMem As Long, prop As MIDIPROPTIMEDIV
    
    If midiStreamOpen(Handle, uDevice, 1, 0, 0, CALLBACK_NULL) = MMSYSERR_NOERROR Then
        prop.cbStruct = Len(prop)
        prop.dwTimeDiv = Val(Text1.Text)
        midiStreamProperty Handle, prop, MIDIPROP_SET Or MIDIPROP_TIMEDIV
        
        hMem = GlobalAlloc(GPTR, lSize)
        CopyMemory ByVal hMem, Phrase(0), lSize
        
        mHdr.lpData = hMem  ' or VarPtr(Phrase(0)) without the global memory junk, but Phrase(0) might moved by VB unexpectedly
        mHdr.dwBufferLength = lSize
        mHdr.dwBytesRecorded = lSize - 4
        
        If midiOutPrepareHeader(Handle, mHdr, Len(mHdr)) = MMSYSERR_NOERROR Then
            midiStreamOut Handle, mHdr, Len(mHdr)
        End If
        midiStreamRestart Handle
        Do While midiOutUnprepareHeader(Handle, mHdr, Len(mHdr)) = MIDIERR_STILLPLAYING: DoEvents: Loop
        midiStreamClose Handle
        GlobalFree hMem
    End If
End Sub

Private Sub Form_Load()
    Command1_Click
End Sub
